/*
 Title:porductlist
 Author:yang sen
 Date:2016-8-13 12:57:45
 Version:v1.0
 */
define(function(){
	var PORDUCTLIST = (function(){
		var API = "";
		var dqhqObj = [$("#app-recommend-huoqi"), $("#app-recommend-dingqi"), $("#app-recommend"),$("#app-recommend-zero")];
		var proPanel = [$("#app-recommend-zero"),$("#app-recommend-15d"),$("#app-recommend-new"),$("#app-recommend-tn"),$("#app-recommend-scat")];
		var proWrap = [$("#product-wrap-zero"),$("#product-wrap-15d"),$("#product-wrap-new"),$("#product-wrap-tn"),$("#product-wrap-scat")];

		return{

			//初始化
			init:function(data){
				//this.getData();
				this.recommendTn(data.tn);
				this.recommendNew(data.tnnew);
				this.recommendScat(data.scat);
				this.recommend15D(data.tn15d);
// 				this.recommend(data);
				this.recommendZero();
				this.pageInit();
				this.dataObj = data;
			},
			pageInit:function(){
				var _this = this;
				//绑定事件
				if(_this.bind){
					_this.bindEvent();
				}

				if(mui.os.ios){
					mui(".product_zero-scroll").scroll({
						deceleration: 0.0005,
						scrollX: true, //是否横向滚动
						scrollY: true, //是否横向滚动
					});
				}
			},
			recommendTn:function(data){
				var _this = this;
				var prodList = data;
				var productHtml = '';
				if (!$.isEmptyObject(prodList)) {
					for (var i in prodList) {
						productHtml += _this.getProductHtml(prodList[i],i);
					}
					proPanel[3].show();
				} else {
					proPanel[3].hide();
				}
				proWrap[3].html(productHtml);
			},
			recommend15D:function(data){
				var _this = this;
				var prodList = data;
				var productHtml = '';
				if (!$.isEmptyObject(prodList)) {
					for (var i in prodList) {
						productHtml += _this.getProductHtml(prodList[i],i);
					}
					proPanel[1].show();
				} else {
					proPanel[1].hide();
				}
				proWrap[1].html(productHtml);
			},
			recommendNew:function(data){
				var _this = this;
				var prodList = data;
				var productHtml = '';
				if (!$.isEmptyObject(prodList)) {
					for (var i in prodList) {
						productHtml += _this.getProductHtml(prodList[i],i);
					}
					proPanel[2].show();
				} else {
					proPanel[2].hide();
				}
				proWrap[2].html(productHtml);
			},
			recommendScat:function(data){
				var _this = this;
				var prodList = data;
				var productHtml = '';
				if (!$.isEmptyObject(prodList)) {
					for (var i in prodList) {
						productHtml += _this.getProductHtml(prodList[i],i);
					}
					proPanel[4].show();
				} else {
					proPanel[4].hide();
				}
				proWrap[4].html(productHtml);
			},
			recommend:function(data){
				//1.8.5企业散标废弃此方法
				var _this = this;
				var prodList = data;
				var productHtml = '';
				if (!$.isEmptyObject(prodList)) {

					for (var i in prodList) {
						//快定宝
						if (prodList[i].subType==='07'){
                            productHtml += _this.getKdbHtml(prodList[i],i)
							continue;
						}
						//tn:定期 t0:活期
						if(prodList[i].type == "PRODUCTTYPE_02"){
							productHtml += _this.getProduct0Html(prodList[i],i);
						}else{
							productHtml += _this.getProductHtml(prodList[i],i);
						}
					}
				}

				dqhqObj[2].html(productHtml);
			},
			recommendZero:function(){
				var _this = this;
				var zeroHtml = '';
				GHUTILS.LOAD({
					url: GHUTILS.API.TARGET.getzerolist,
					type: "post",
					params: {
						channelOid: channelOid,
						page: 1,
						rows: 10,
						expArorStart: "",
						expArorEnd: "",
						durationPeriodDaysStart: "",
						durationPeriodDaysEnd: ""
					},
					sw: false,
					callback: function(result) {
						if (GHUTILS.checkErrorCode(result)) {
							var list = result.rows;
							if(list && list.length > 0){
								for(var i in list){
									zeroHtml += _this.getZeroHtml(list[i])
								}
								$(".app_product_zero_wrap").html(zeroHtml);
								//跳转0元购详情
								$(".product-zero-item").off().on("tap", function(event) {
									// 友盟监听
									GHUTILS.OPENPAGE({
										url: "../product-tn/product-tn-detail.html",
										id: GHUTILS.PAGESID.PROTNDETAIL,
										extras: {
											productOid: $(this).attr("data-href"),
											subType:$(this).attr("data-subType"),
										}
									})
									GHUTILS.nativeUI.showWaiting();

								});
								proPanel[0].show();
							}else{
								proPanel[0].hide();
							}
						}
					}
				})
			},
			//0元购列表
			getZeroHtml: function(tradeObj,index){
				var _this = this;
				var producZeroHtml = '<div class="product-zero-item" data-href="' +
				tradeObj.productOid + '" data-subType="'+tradeObj.subType+'">'+
				'<h3 class="product-zero-item-title"><span class="app_tag_flag app_tag_c5 app_mr5 app_ml0">送</span>'+tradeObj.name+'</h3>'+
				'<div class="app_cf90 app_f22 app_mt8 app_mb2">'+tradeObj.expectedArrorDisp+'</div>'+
				'<p>折算年化收益率</p>'+
				'<p>投资期限：'+tradeObj.durationPeriodDays+'天</p>'+
				'</div>';

				return producZeroHtml;
			},
			//活期产品
			getProduct0Html: function(tradeObj,index) {
				var _this = this;
				var type = '', soldOut = '';
				var product0Html = '';

//				判断活期类型
				var subType = tradeObj.subType;

				if(!tradeObj.investMin){
					tradeObj.investMin = 0
				}
				if(tradeObj.maxSaleVolume == tradeObj.lockCollectedVolume || GHUTILS.Fmul(GHUTILS.Fsub(tradeObj.maxSaleVolume, tradeObj.lockCollectedVolume), 1) < tradeObj.investMin){
					type += '<span class="app_tag_icon">售罄</span>';
					soldOut = " sold_out";
				}
				if(GHUTILS.isLabelProduct(tradeObj.labelList, "experienceFund", true)){
					product0Html = ''
				}else if(GHUTILS.isLabelProduct(tradeObj.labelList, "005", true)){
					type = '<img src="../../images/icon-pro-hot.png" alt="理财爆品" />';
					if(subType == 3){
						product0Html = '<div class="app_in_product_card app_huoqi' +
						soldOut + '"><div class="app-recommend-huoqi" data-href="' +
						tradeObj.productOid + '" data-subType="'+tradeObj.subType+'"><div class="app_in_product_title">' +
						tradeObj.name+type+'</div><div class="app_pt20 text-align-center"><div class="app_cf90 "><span class="app_f32">'+ this.showExpArror(tradeObj) + '%</span></div><p class="app_f15 app_c80 app_mt8">昨日年化收益率</p></div></div><div class="app_mt20 app-btn-huoqi" data-href="' + tradeObj.productOid + '" data-subType="'+tradeObj.subType+'"><button type="button" class="mui-btn mui-btn-primary mui-btn-block">立即存入</button></div><div class="app_clearfix app_mt20 app_f13 app_c80"><div class="mui-col-xs-5 app_fl text-align-center">起购金额:'+Math.round(tradeObj.investMin)+'元</div><div class="mui-col-xs-3 app_fl text-align-center">阶梯计息</div><div class="mui-col-xs-4 app_fl text-align-center">T+2到账</div></div></div>';
					}else{
						product0Html = '<div class="app_in_product_card app_huoqi' +
						soldOut + '"><div class="app-recommend-huoqi" data-href="' +
						tradeObj.productOid + '" data-subType="'+tradeObj.subType+'"><div class="app_in_product_title">' +
						tradeObj.name+type+'</div><div class="app_pt24 text-align-center"><div class="app_cf90 "><span class="app_f49">'+ this.showExpArror(tradeObj) + '%</span></div><p class="app_f15 app_c80 app_mt8">昨日年化收益率</p></div></div><div class="app_mt20 app-btn-huoqi" data-href="' + tradeObj.productOid + '" data-subType="'+tradeObj.subType+'"><button type="button" class="mui-btn mui-btn-primary mui-btn-block">立即存入</button></div><div class="app_clearfix app_mt20 app_f13 app_c80"><div class="mui-col-xs-5 app_fl text-align-center">起购金额:'+Math.round(tradeObj.investMin)+'元</div><div class="mui-col-xs-3 app_fl text-align-center">复利计息</div><div class="mui-col-xs-4 app_fl text-align-center">随时可退</div></div></div>';
					}

				}else{
					type += GHUTILS.showProductLabels(tradeObj.labelList);
					product0Html = '<div class="app_product_ihbox app-recommend-huoqi' +
						soldOut + '" data-href="' +
						tradeObj.productOid + '"><div class="app_product_ihbox_title app_c4">' +
						tradeObj.name +type+ '</div><div class="app_product_ihcon app_clearfix app_pb15"><div class="app_product_ihview app_fl app_pt5 mui-col-xs-5"><div class="app_cf90 "><span class="app_f18">'+
						_this.showExpArror(tradeObj) + '%</span></div><p class="app_f14 app_cb3a app_mt8 app_c8">预期年化收益率</p></div><div class="app_product_ihview app_fl mui-col-xs-7 app_pl10 app_pt5 pp_pb5 app_f14 app_c4"><span class="app_c8">起投金额：</span>' +
						GHUTILS.formatCurrency(tradeObj.investMin) + '元<div class="app_mt10"><span class="app_c8">投资人次：</span>' +
						GHUTILS.formatIntCurrency(tradeObj.purchaseNum || 0) + '</div></div></div></div>';
				}

				return product0Html;
			},
			//快定宝产品
			getKdbHtml: function(tradeObj,index){
                var productHtml = "";
                var btnTxt = "立即抢购";
                var btnClass = "";
                if(!tradeObj.investMin){
                    tradeObj.investMin = 0
                }
                if(tradeObj.state != "RAISING"){
                    btnClass = "btn-disable";
                    btnTxt = "募集结束";

                }else if(GHUTILS.Fadd(tradeObj.collectedVolume, GHUTILS.Fmul(tradeObj.lockCollectedVolume, 1)) == tradeObj.raisedTotalNumber || GHUTILS.Fsub(tradeObj.raisedTotalNumber, GHUTILS.Fadd(tradeObj.collectedVolume, GHUTILS.Fmul(tradeObj.lockCollectedVolume, 1))) <= 0){

                    btnClass = "btn-disable";
                    btnTxt = "售 罄";

                }//剩余可投为0则为售罄
                var type = '', soldOut = '';
                type += GHUTILS.showProductLabels(tradeObj.labelList);
                productHtml = '<div class="app-recommend-dingqi ' + soldOut + '" data-href="'+tradeObj.productOid + '" data-subType="'+tradeObj.subType+'">\n' +
                    '    <div class="app_product_ihbox_title app_f16 app_clearfix">\n' +
                    '        <div class="app_f15">\n' + tradeObj.name + type +
                    '        </div>\n' +
                    '        <div class="app_product_ihcon app_clearfix app_mt10 ">\n' +
                    '            <div class="app_product_ihview app_fl app_pt5 mui-col-xs-5">\n' +
                    '                <p class="app_f14 app_cb3a">\n' +
                    '                    预期年化收益率\n' +
                    '                </p>\n' +
                    '                <div class="app_cf90 app_mt10" style="margin-bottom: 5px;">\n' +
                    '                    <span class="app_f24">\n' + tradeObj.expArrorDisp +
                    '                    </span>\n' +
                    '                </div>\n' +
                    '                <div>\n' +
                    '                \t<span class="app_15days_tag">自动续投 随时赎回</span>\n' +
                    '                </div>\n' +
                    '            </div>\n' +
                    '            <div class="app_product_ihview app_fl mui-col-xs-7 app_pl10 app_pt5 app_pb5 app_f14 app_mt30">\n' +
                    '                <div style="margin-bottom: 12px;">\n' +
                    '                    投资期限：\n' +
                    '                    <span class="app_cf90">\n' + tradeObj.durationPeriodDays + '天' +
                    '                    </span>\n' +
                    '                </div>\n' +
                    '                <div class="app_txt_nowrap">\n' +
                    '                    起投金额：\n' +
                    '                    <span class="app_cf90 app_txt_nowrap">' + GHUTILS.formatCurrency(tradeObj.investMin) + '元' +
                    '                    </span>\n' +
                    '                </div>\n' +
                    '            </div>\n' +
                    '        </div>\n' +
                    '        <button type="button" data-href="'+tradeObj.productOid + '" class="mui-btn mui-btn-primary mui-btn-block app_mt10 invest-tn '+btnClass+'">\n' +
                    '            立即抢购\n' +
                    '        </button>\n' +
                    '    </div>\n' +
                    '</div>'
				return productHtml
			},
			//定期产品,新手标,15D,散标模板
			getProductHtml: function(tradeObj,index) {
				var prodctHtml = "";
				var aniNum = tradeObj.expArrorDisp.split("~");
				var badge = "";//产品徽章
				var numCls = "app_f30";//收益数字样式
				if(aniNum.length > 1){
					var animin = aniNum[0].replace("%","");
					var animax = aniNum[1].replace("%","");
					aniNum = animin + "-" + animax;
					numCls = "app_f22"
				}else{
					aniNum = aniNum[0].replace("%","");
					numCls = "app_f30"
				}

				var collectPercent = GHUTILS.toFixeds(GHUTILS.Fmul(GHUTILS.Fdiv(GHUTILS.Fadd(tradeObj.collectedVolume, GHUTILS.Fmul(tradeObj.lockCollectedVolume, 1)), tradeObj.raisedTotalNumber), 100),2);
				var type = '', soldOut = '';
				if(!tradeObj.investMin){
					tradeObj.investMin = 0
				}

				var stateLogo = '';//产品状态标识
				var stateCls = '';//产品状态滤镜
				if(tradeObj.state != "RAISING" || (tradeObj.subType == "08" && tradeObj.state != "RAISING" && tradeObj.state != "DURATIONING")){
					stateCls = 'filter-gray';
					stateLogo = tradeObj.subType == "08" ? '<div class="product-status-img status-end"></div>' : '<div class="product-status-img status-raised"></div>'
				}else if(GHUTILS.Fadd(tradeObj.collectedVolume, GHUTILS.Fmul(tradeObj.lockCollectedVolume, 1)) == tradeObj.raisedTotalNumber || GHUTILS.Fsub(tradeObj.raisedTotalNumber, GHUTILS.Fadd(tradeObj.collectedVolume, GHUTILS.Fmul(tradeObj.lockCollectedVolume, 1))) <= 0){
					stateCls = 'filter-gray';
					stateLogo = tradeObj.subType == "08" ? '<div class="product-status-img status-full"></div>' : '<div class="product-status-img status-soldout"></div>'

				}//剩余可投为0则为售罄

				type += GHUTILS.showProductLabels(tradeObj.labelList);
				if(tradeObj.subType == "08"){ 
					badge = '<img src="../../images/badge-scat.png" class="app_product_badge"  alt="企业借款">'

					prodctHtml = '<div class="app_product_ihbox_title app-product-box app-recommend-dingqi app_f16 app_clearfix '+stateCls+'" data-href="'+tradeObj.productOid + '" data-subType="'+tradeObj.subType+'">'
						+'<div>' +tradeObj.name+'</div>' +
						'<div class="app_product_ihcon app_clearfix app_mt15">' +
						'<div class="app_product_ihview app_fl mui-col-xs-6 app_bre">' +
						'<div class="app_cf90">' +
						'<span class="'+numCls+'">'
						+aniNum + '%</span>' +
						'</div>' +
						'<p class="app_f12 app_c9">年化利率</p>' +
						'</div>' +
						'<div class="app_product_ihview app_fl mui-col-xs-6 app_pl10 app_pb5 app_f12 app_c9">' +
						'<div class="app_txt_nowrap"><span class="app_f18 app_mr5 app_c6">'+tradeObj.durationPeriodDays+'</span>天</div>'+
						'<div class="app_txt_nowrap"><span class="app_f18 app_mr5 app_c6">'+GHUTILS.formatCurrency(tradeObj.raisedTotalNumber)+'</span>元</div>'+
						'</div>' +
						'</div>' +
						badge +
						stateLogo +
						'</div>';
				}else {
					prodctHtml = '<div class="app_product_ihbox_title app-product-box app-recommend-dingqi app_f16 app_clearfix '+stateCls+'" data-href="'+tradeObj.productOid + '">'
						+'<div>' +tradeObj.name+type+'</div>' +
						'<div class="app_product_ihcon app_clearfix app_mt15">' +
						'<div class="app_product_ihview app_fl mui-col-xs-6 app_bre">' +
						'<div class="app_cf90">' +
						'<span class="'+numCls+'">'
						+aniNum + '%</span>' +
						'</div>' +
						'<p class="app_f12 app_c9">预期年化收益率</p>' +
						'</div>' +
						'<div class="app_product_ihview app_fl mui-col-xs-6 app_pl10 app_pb5 app_f12 app_c9">' +
						'<div class="app_txt_nowrap"><span class="app_f18 app_mr5 app_c6">'+tradeObj.durationPeriodDays+'</span>天</div>'+
						'<div class="app_txt_nowrap"><span class="app_f18 app_mr5 app_c6">'+GHUTILS.formatCurrency(tradeObj.investMin)+'</span>元起投</div>'+
						'</div>' +
						'</div>' +
						badge +
						stateLogo +
						'</div>';
				}


//				}
				return prodctHtml;
			},
			showExpArror: function(tradeObj){
				var expArror = tradeObj.expArrorDisp.replace(/\%/g,'').split("~")
				if(expArror.length > 1){
					return expArror[0] + "-" + expArror[1]
				}else{
					return expArror[0]
				}

			},
			bindEvent:function(){
				var _this = this;
				var ws = plus.webview.currentWebview();

				//定期
				$(".app-recommend-dingqi").off().on("tap", function(event) {
					//因为散标产品详情页与定期详情UI差异较大，重新写了一个页面。需要判断一下跳到不同产品详情
					if ($(this).attr("data-subType") == "08") {
						GHUTILS.OPENPAGE({
							url: "../product-scat/product-scat-detail.html",
							id: GHUTILS.PAGESID.PROTNDETAIL,
							extras: { 
								productOid: $(this).attr("data-href"),
	//								collectPercent: $(this).attr("data-collectPercent") || 0
							}
						})
					} else{
						GHUTILS.OPENPAGE({
							url: "../product-tn/product-tn-detail.html",
							id: GHUTILS.PAGESID.PROTNDETAIL,
							extras: {
								productOid: $(this).attr("data-href"),
	//								collectPercent: $(this).attr("data-collectPercent") || 0
							}
						})
					}
					GHUTILS.nativeUI.showWaiting();

				});

				//更多定期
				$("#more-tn").off().on("tap",function () {
					GHUTILS.openCodePage("T2",1)
				})
				
				//更多散标
				$("#more-scat").off().on("tap",function () {
					GHUTILS.openCodePage("scatCom",1)
				})

			},
			gett0detail: function(oid,subType){

				var _this = this;
				GHUTILS.LOAD({
					url: GHUTILS.API.TARGET.gett0detail+"?oid="+oid,
					type: "post",
					sw: true,
					callback: function(result) {
						console.log("活期详情:"+JSON.stringify(result))
						var productCode = result.productCode;
//						alert(GHUTILS.switchShowType(result, false).interestSec.split('-'));

						if(GHUTILS.checkErrorCode(result)){
							if(!result.investMin){
								result.investMin = 0
							}
							if(!result.investMax){
								result.investMax = 0
							}
							if(result.state == "RAISEEND"){
								mui.toast("产品募集结束！")
							}else if(result.maxSaleVolume == result.lockCollectedVolume || GHUTILS.Fmul(GHUTILS.Fsub(result.maxSaleVolume, result.lockCollectedVolume), result.netUnitShare) < result.investMin){
								mui.toast("产品已售罄！")
							}else if(result.isOpenPurchase == "NO"){
								mui.toast("产品不可购买！")
							}else{
								_this.isLogin(function(){
									if(!GHUTILS.checkDepWit()){
										return
									}
									if(GHUTILS.isLabelProduct(result.productLabels, "1", true)){
										if(!GHUTILS.isFreshman()){
											return
										}
									}


									if(subType == "03"){

										GHUTILS.OPENPAGE({
											url:"../../html/product-ddup/product-ddup-order.html",
											id:GHUTILS.PAGESID.PROT0ORDER,
											extras:{
												productName: result.productName,
												productOid: result.oid,
												annualInterestSec: result.annualInterestSec.split("-"),
												incomeCalcBasis: Number(result.incomeCalcBasis),
												purchasingAmount: result.investMin,
												increaseAmount: GHUTILS.Fmul(result.investAdditional, result.netUnitShare),
												maxSaleVolume: GHUTILS.Fmul(GHUTILS.Fsub(result.maxSaleVolume, result.lockCollectedVolume), result.netUnitShare),
												investMax: GHUTILS.Fmul(result.investMax, result.netUnitShare),
												investVolume: parseFloat("1000"),
												investFiles: HOST+result.investFiles[0].furl,
												serviceFiles: HOST+result.serviceFiles[0].furl,
												files:HOST+result.files[0].furl,
												productCode: result.productCode,
												interestsFirstDays: result.interestsFirstDays,
												interestsFirstDate: result.interestsFirstDate.split("-"),
												maxHold: result.maxHold,
												companyName: result.companyName,
												singleDailyMaxRedeem: result.singleDailyMaxRedeem,
												singleDayRedeemCount: result.singleDayRedeemCount,
												isShowRedPackets : result.isShowRedPacketsNew,
												isShowRaiseCoupons : result.isShowRaiseCoupons,
											}
										})
									}else{

										GHUTILS.OPENPAGE({
											url:"../../html/product-t0/product-t0-order.html",
											id:GHUTILS.PAGESID.PROT0ORDER,
											extras:{
												productName: result.productName,
												productOid: result.oid,
												annualInterestSec: GHUTILS.switchShowType(result, false).interestSec.split('-'),
												incomeCalcBasis: Number(result.incomeCalcBasis),
												purchasingAmount: result.investMin,
												increaseAmount: GHUTILS.Fmul(result.investAdditional, result.netUnitShare),
												maxSaleVolume: GHUTILS.Fmul(GHUTILS.Fsub(result.maxSaleVolume, result.lockCollectedVolume), result.netUnitShare),
												investMax: GHUTILS.Fmul(result.investMax, result.netUnitShare),
												investVolume: parseFloat("1000"),
												investFiles: HOST+result.investFiles[0].furl,
												serviceFiles: HOST+result.serviceFiles[0].furl,
//												files:HOST+result.files[0].furl,
												productCode: result.productCode,
												interestsFirstDays: result.interestsFirstDays,
												interestsFirstDate: result.interestsFirstDate.split("-"),
												maxHold: result.maxHold,
												companyName: result.companyName,
												singleDailyMaxRedeem: result.singleDailyMaxRedeem,
												singleDayRedeemCount: result.singleDayRedeemCount,
												isShowRedPackets : result.isShowRedPacketsNew,
												isShowRaiseCoupons : result.isShowRaiseCoupons,
											}
										})
									}

									GHUTILS.nativeUI.showWaiting();
								})
							}
						}
					}
				})
			},
			isLogin: function(ifTrue){
				var _this = this;
				GHUTILS.LOAD({
					url: GHUTILS.API.CHA.islogin,
					type: "post",
					callback: function(result){
						if(GHUTILS.checkErrorCode(result)){
							if(result.islogin){
								ifTrue.apply(null, arguments)
							}else{
								GHUTILS.loginOut(function(){
									var cb = {
										cb:"reload",
										pageid:plus.webview.currentWebview().id
									}
									GHUTILS.openLogin(JSON.stringify(cb));
								});
							}
						}
					}
				})
			},
			dateInit:function(){

			}
		}
	})();

	$["productlist"] = function(data){
		PORDUCTLIST.bind = getCfgBind("productlist");
		PORDUCTLIST.init(data);
	}
})